<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for src/onaptests/actions/instantiate.py: 84%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">
<div id="header">
    <div class="content">
        <h1>Coverage for <b>src/onaptests/actions/instantiate.py</b> :
            <span class="pc_cov">84%</span>
        </h1>
        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />
        <h2 class="stats">
            178 statements &nbsp;
            <span class="run shortkey_r button_toggle_run">150 run</span>
            <span class="mis show_mis shortkey_m button_toggle_mis">28 missing</span>
            <span class="exc show_exc shortkey_x button_toggle_exc">0 excluded</span>
        </h2>
    </div>
</div>
<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>
<div id="source">
    <p id="t1" class="pln"><span class="n"><a href="#t1">1</a></span><span class="t"><span class="com">#!/usr/bin/python</span>&nbsp;</span><span class="r"></span></p>
    <p id="t2" class="pln"><span class="n"><a href="#t2">2</a></span><span class="t"><span class="com">#</span>&nbsp;</span><span class="r"></span></p>
    <p id="t3" class="pln"><span class="n"><a href="#t3">3</a></span><span class="t"><span class="com"># This program and the accompanying materials</span>&nbsp;</span><span class="r"></span></p>
    <p id="t4" class="pln"><span class="n"><a href="#t4">4</a></span><span class="t"><span class="com"># are made available under the terms of the Apache License, Version 2.0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t5" class="pln"><span class="n"><a href="#t5">5</a></span><span class="t"><span class="com"># which accompanies this distribution, and is available at</span>&nbsp;</span><span class="r"></span></p>
    <p id="t6" class="pln"><span class="n"><a href="#t6">6</a></span><span class="t"><span class="com">#</span>&nbsp;</span><span class="r"></span></p>
    <p id="t7" class="pln"><span class="n"><a href="#t7">7</a></span><span class="t"><span class="com"># http://www.apache.org/licenses/LICENSE-2.0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t8" class="pln"><span class="n"><a href="#t8">8</a></span><span class="t"><span class="com">#</span>&nbsp;</span><span class="r"></span></p>
    <p id="t9" class="pln"><span class="n"><a href="#t9">9</a></span><span class="t"><span class="com">#  pylint: disable=duplicate-code</span>&nbsp;</span><span class="r"></span></p>
    <p id="t10" class="pln"><span class="n"><a href="#t10">10</a></span><span class="t"><span class="com">#  pylint: disable=missing-docstring</span>&nbsp;</span><span class="r"></span></p>
    <p id="t11" class="pln"><span class="n"><a href="#t11">11</a></span><span class="t"><span class="com">#  pylint: disable=too-many-branches</span>&nbsp;</span><span class="r"></span></p>
    <p id="t12" class="pln"><span class="n"><a href="#t12">12</a></span><span class="t"><span class="com">#  pylint: disable=too-many-public-methods</span>&nbsp;</span><span class="r"></span></p>
    <p id="t13" class="run"><span class="n"><a href="#t13">13</a></span><span class="t"><span class="str">"""Instantiation class."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t14" class="run"><span class="n"><a href="#t14">14</a></span><span class="t"><span class="key">import</span> <span class="nam">time</span>&nbsp;</span><span class="r"></span></p>
    <p id="t15" class="run"><span class="n"><a href="#t15">15</a></span><span class="t"><span class="key">import</span> <span class="nam">sys</span>&nbsp;</span><span class="r"></span></p>
    <p id="t16" class="pln"><span class="n"><a href="#t16">16</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t17" class="run"><span class="n"><a href="#t17">17</a></span><span class="t"><span class="key">from</span> <span class="nam">onapsdk</span><span class="op">.</span><span class="nam">configuration</span> <span class="key">import</span> <span class="nam">settings</span>&nbsp;</span><span class="r"></span></p>
    <p id="t18" class="pln"><span class="n"><a href="#t18">18</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t19" class="pln"><span class="n"><a href="#t19">19</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t20" class="run"><span class="n"><a href="#t20">20</a></span><span class="t"><span class="key">from</span> <span class="nam">onapsdk</span><span class="op">.</span><span class="nam">aai</span><span class="op">.</span><span class="nam">business</span> <span class="key">import</span> <span class="nam">Customer</span>&nbsp;</span><span class="r"></span></p>
    <p id="t21" class="run"><span class="n"><a href="#t21">21</a></span><span class="t"><span class="key">from</span> <span class="nam">onapsdk</span><span class="op">.</span><span class="nam">so</span><span class="op">.</span><span class="nam">instantiation</span> <span class="key">import</span> <span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t22" class="pln"><span class="n"><a href="#t22">22</a></span><span class="t">    <span class="nam">ServiceInstantiation</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t23" class="pln"><span class="n"><a href="#t23">23</a></span><span class="t">    <span class="nam">VnfParameter</span>&nbsp;</span><span class="r"></span></p>
    <p id="t24" class="pln"><span class="n"><a href="#t24">24</a></span><span class="t"><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t25" class="run"><span class="n"><a href="#t25">25</a></span><span class="t"><span class="key">from</span> <span class="nam">onapsdk</span><span class="op">.</span><span class="nam">sdc</span><span class="op">.</span><span class="nam">service</span> <span class="key">import</span> <span class="nam">Service</span>&nbsp;</span><span class="r"></span></p>
    <p id="t26" class="pln"><span class="n"><a href="#t26">26</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t27" class="run"><span class="n"><a href="#t27">27</a></span><span class="t"><span class="key">from</span> <span class="nam">onaptests</span><span class="op">.</span><span class="nam">actions</span><span class="op">.</span><span class="nam">common</span> <span class="key">import</span> <span class="nam">Common</span>&nbsp;</span><span class="r"></span></p>
    <p id="t28" class="pln"><span class="n"><a href="#t28">28</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t29" class="run"><span class="n"><a href="#t29">29</a></span><span class="t"><span class="key">class</span> <span class="nam">Instantiate</span><span class="op">(</span><span class="nam">Common</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t30" class="pln"><span class="n"><a href="#t30">30</a></span><span class="t">    <span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t31" class="pln"><span class="n"><a href="#t31">31</a></span><span class="t"><span class="str">    Class to automate the instantiation of a service including VNF and VF</span>&nbsp;</span><span class="r"></span></p>
    <p id="t32" class="pln"><span class="n"><a href="#t32">32</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t33" class="pln"><span class="n"><a href="#t33">33</a></span><span class="t"><span class="str">    It is assumed that the Design phase has been already done</span>&nbsp;</span><span class="r"></span></p>
    <p id="t34" class="pln"><span class="n"><a href="#t34">34</a></span><span class="t"><span class="str">    The yaml template is available and stored in the template directory</span>&nbsp;</span><span class="r"></span></p>
    <p id="t35" class="pln"><span class="n"><a href="#t35">35</a></span><span class="t"><span class="str">    """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t36" class="pln"><span class="n"><a href="#t36">36</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t37" class="run"><span class="n"><a href="#t37">37</a></span><span class="t">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="op">**</span><span class="nam">kwargs</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t38" class="pln"><span class="n"><a href="#t38">38</a></span><span class="t">        <span class="str">"""Initialize Solution object."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t39" class="run"><span class="n"><a href="#t39">39</a></span><span class="t">        <span class="nam">super</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t40" class="run"><span class="n"><a href="#t40">40</a></span><span class="t">        <span class="key">if</span> <span class="str">"service_name"</span> <span class="key">in</span> <span class="nam">kwargs</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t41" class="run"><span class="n"><a href="#t41">41</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">service_name</span> <span class="op">=</span> <span class="nam">kwargs</span><span class="op">[</span><span class="str">'service_name'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t42" class="pln"><span class="n"><a href="#t42">42</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t43" class="run"><span class="n"><a href="#t43">43</a></span><span class="t">            <span class="key">raise</span> <span class="nam">ValueError</span><span class="op">(</span><span class="str">"Service Name to define"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t44" class="run"><span class="n"><a href="#t44">44</a></span><span class="t">        <span class="key">if</span> <span class="str">"instance_name"</span> <span class="key">in</span> <span class="nam">kwargs</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t45" class="run"><span class="n"><a href="#t45">45</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">instance_name</span> <span class="op">=</span> <span class="nam">kwargs</span><span class="op">[</span><span class="str">'instance_name'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t46" class="pln"><span class="n"><a href="#t46">46</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t47" class="run"><span class="n"><a href="#t47">47</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">instance_name</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">service_name</span>&nbsp;</span><span class="r"></span></p>
    <p id="t48" class="run"><span class="n"><a href="#t48">48</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">vf_list</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t49" class="run"><span class="n"><a href="#t49">49</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">customer</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t50" class="run"><span class="n"><a href="#t50">50</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">service_subscription</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t51" class="pln"><span class="n"><a href="#t51">51</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t52" class="run"><span class="n"><a href="#t52">52</a></span><span class="t">    <span class="key">def</span> <span class="nam">create_customer</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">customer_id</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t53" class="pln"><span class="n"><a href="#t53">53</a></span><span class="t">        <span class="str">"""Create customer if it does not exist."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t54" class="run"><span class="n"><a href="#t54">54</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Create Customer *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t55" class="run"><span class="n"><a href="#t55">55</a></span><span class="t">        <span class="nam">customer</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t56" class="run"><span class="n"><a href="#t56">56</a></span><span class="t">        <span class="key">for</span> <span class="nam">found_customer</span> <span class="key">in</span> <span class="nam">list</span><span class="op">(</span><span class="nam">Customer</span><span class="op">.</span><span class="nam">get_all</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t57" class="run"><span class="n"><a href="#t57">57</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"Customer %s found"</span><span class="op">,</span> <span class="nam">found_customer</span><span class="op">.</span><span class="nam">subscriber_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t58" class="run"><span class="n"><a href="#t58">58</a></span><span class="t">            <span class="key">if</span> <span class="nam">found_customer</span><span class="op">.</span><span class="nam">subscriber_name</span> <span class="op">==</span> <span class="nam">customer_id</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t59" class="run"><span class="n"><a href="#t59">59</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Customer %s found"</span><span class="op">,</span> <span class="nam">found_customer</span><span class="op">.</span><span class="nam">subscriber_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t60" class="run"><span class="n"><a href="#t60">60</a></span><span class="t">                <span class="nam">customer</span> <span class="op">=</span> <span class="nam">found_customer</span>&nbsp;</span><span class="r"></span></p>
    <p id="t61" class="run"><span class="n"><a href="#t61">61</a></span><span class="t">                <span class="key">break</span>&nbsp;</span><span class="r"></span></p>
    <p id="t62" class="run"><span class="n"><a href="#t62">62</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">customer</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t63" class="run"><span class="n"><a href="#t63">63</a></span><span class="t">            <span class="nam">customer</span> <span class="op">=</span> <span class="nam">Customer</span><span class="op">.</span><span class="nam">create</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t64" class="pln"><span class="n"><a href="#t64">64</a></span><span class="t">                <span class="nam">customer_id</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t65" class="pln"><span class="n"><a href="#t65">65</a></span><span class="t">                <span class="nam">customer_id</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t66" class="pln"><span class="n"><a href="#t66">66</a></span><span class="t">                <span class="str">"INFRA"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t67" class="run"><span class="n"><a href="#t67">67</a></span><span class="t">        <span class="key">return</span> <span class="nam">customer</span>&nbsp;</span><span class="r"></span></p>
    <p id="t68" class="pln"><span class="n"><a href="#t68">68</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t69" class="run"><span class="n"><a href="#t69">69</a></span><span class="t">    <span class="key">def</span> <span class="nam">declare_service_subscription</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">customer</span><span class="op">,</span> <span class="nam">service</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t70" class="pln"><span class="n"><a href="#t70">70</a></span><span class="t">        <span class="str">"""Declare service subscription if not created."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t71" class="run"><span class="n"><a href="#t71">71</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Check Service Subscription *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t72" class="run"><span class="n"><a href="#t72">72</a></span><span class="t">        <span class="nam">service_subscription</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t73" class="run"><span class="n"><a href="#t73">73</a></span><span class="t">        <span class="key">for</span> <span class="nam">service_sub</span> <span class="key">in</span> <span class="nam">customer</span><span class="op">.</span><span class="nam">service_subscriptions</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t74" class="run"><span class="n"><a href="#t74">74</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"Service subscription %s is found"</span><span class="op">,</span> <span class="nam">service_sub</span><span class="op">.</span><span class="nam">service_type</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t75" class="run"><span class="n"><a href="#t75">75</a></span><span class="t">            <span class="key">if</span> <span class="nam">service_sub</span><span class="op">.</span><span class="nam">service_type</span> <span class="op">==</span> <span class="nam">service</span><span class="op">.</span><span class="nam">name</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t76" class="run"><span class="n"><a href="#t76">76</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Service %s subscribed"</span><span class="op">,</span> <span class="nam">service</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t77" class="run"><span class="n"><a href="#t77">77</a></span><span class="t">                <span class="nam">service_subscription</span> <span class="op">=</span> <span class="nam">service_sub</span>&nbsp;</span><span class="r"></span></p>
    <p id="t78" class="run"><span class="n"><a href="#t78">78</a></span><span class="t">                <span class="key">break</span>&nbsp;</span><span class="r"></span></p>
    <p id="t79" class="pln"><span class="n"><a href="#t79">79</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t80" class="run"><span class="n"><a href="#t80">80</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">service_subscription</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t81" class="run"><span class="n"><a href="#t81">81</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Subscribe Service *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t82" class="run"><span class="n"><a href="#t82">82</a></span><span class="t">            <span class="nam">service_subscription</span> <span class="op">=</span> <span class="nam">customer</span><span class="op">.</span><span class="nam">subscribe_service</span><span class="op">(</span><span class="nam">service</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t83" class="run"><span class="n"><a href="#t83">83</a></span><span class="t">        <span class="key">return</span> <span class="nam">service_subscription</span>&nbsp;</span><span class="r"></span></p>
    <p id="t84" class="pln"><span class="n"><a href="#t84">84</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t85" class="run"><span class="n"><a href="#t85">85</a></span><span class="t">    <span class="key">def</span> <span class="nam">check_tenant_exists</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">cloud_region</span><span class="op">,</span> <span class="nam">tenant_name</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t86" class="pln"><span class="n"><a href="#t86">86</a></span><span class="t">        <span class="str">"""Check if tenant exists."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t87" class="run"><span class="n"><a href="#t87">87</a></span><span class="t">        <span class="nam">tenant</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t88" class="run"><span class="n"><a href="#t88">88</a></span><span class="t">        <span class="key">for</span> <span class="nam">found_tenant</span> <span class="key">in</span> <span class="nam">cloud_region</span><span class="op">.</span><span class="nam">tenants</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t89" class="run"><span class="n"><a href="#t89">89</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"Tenant %s found in %s_%s"</span><span class="op">,</span> <span class="nam">found_tenant</span><span class="op">.</span><span class="nam">name</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t90" class="pln"><span class="n"><a href="#t90">90</a></span><span class="t">                              <span class="nam">cloud_region</span><span class="op">.</span><span class="nam">cloud_owner</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t91" class="pln"><span class="n"><a href="#t91">91</a></span><span class="t">                              <span class="nam">cloud_region</span><span class="op">.</span><span class="nam">cloud_region_id</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t92" class="run"><span class="n"><a href="#t92">92</a></span><span class="t">            <span class="key">if</span> <span class="nam">found_tenant</span><span class="op">.</span><span class="nam">name</span> <span class="op">==</span> <span class="nam">tenant_name</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t93" class="run"><span class="n"><a href="#t93">93</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Found my Tenant %s"</span><span class="op">,</span> <span class="nam">found_tenant</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t94" class="run"><span class="n"><a href="#t94">94</a></span><span class="t">                <span class="nam">tenant</span> <span class="op">=</span> <span class="nam">found_tenant</span>&nbsp;</span><span class="r"></span></p>
    <p id="t95" class="run"><span class="n"><a href="#t95">95</a></span><span class="t">                <span class="key">break</span>&nbsp;</span><span class="r"></span></p>
    <p id="t96" class="run"><span class="n"><a href="#t96">96</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">tenant</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t97" class="run"><span class="n"><a href="#t97">97</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">"tenant %s not found"</span><span class="op">,</span> <span class="nam">tenant_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t98" class="run"><span class="n"><a href="#t98">98</a></span><span class="t">            <span class="nam">sys</span><span class="op">.</span><span class="nam">exit</span><span class="op">(</span><span class="num">1</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t99" class="run"><span class="n"><a href="#t99">99</a></span><span class="t">        <span class="key">return</span> <span class="nam">tenant</span>&nbsp;</span><span class="r"></span></p>
    <p id="t100" class="pln"><span class="n"><a href="#t100">100</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t101" class="run"><span class="n"><a href="#t101">101</a></span><span class="t">    <span class="key">def</span> <span class="nam">get_vnf_parameters</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">service_name</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t102" class="pln"><span class="n"><a href="#t102">102</a></span><span class="t">        <span class="str">""" get vnf parameters from vnf service yaml file."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t103" class="run"><span class="n"><a href="#t103">103</a></span><span class="t">        <span class="nam">vnf_params</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t104" class="run"><span class="n"><a href="#t104">104</a></span><span class="t">        <span class="nam">vnfparams</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_vnf_parameters_from_sdnc</span><span class="op">(</span><span class="nam">service_name</span><span class="op">,</span> <span class="nam">service_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t105" class="run"><span class="n"><a href="#t105">105</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"VNF parameters are %s"</span><span class="op">,</span> <span class="nam">vnfparams</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t106" class="run"><span class="n"><a href="#t106">106</a></span><span class="t">        <span class="key">for</span> <span class="nam">params</span> <span class="key">in</span> <span class="nam">vnfparams</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t107" class="run"><span class="n"><a href="#t107">107</a></span><span class="t">            <span class="nam">vnf_params</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">VnfParameter</span><span class="op">(</span><span class="nam">name</span><span class="op">=</span><span class="nam">params</span><span class="op">[</span><span class="str">'name'</span><span class="op">]</span><span class="op">,</span> <span class="nam">value</span><span class="op">=</span><span class="nam">params</span><span class="op">[</span><span class="str">'value'</span><span class="op">]</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t108" class="pln"><span class="n"><a href="#t108">108</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t109" class="run"><span class="n"><a href="#t109">109</a></span><span class="t">        <span class="key">return</span> <span class="nam">vnf_params</span>&nbsp;</span><span class="r"></span></p>
    <p id="t110" class="pln"><span class="n"><a href="#t110">110</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t111" class="run"><span class="n"><a href="#t111">111</a></span><span class="t">    <span class="key">def</span> <span class="nam">find_service_sdc</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">service_name</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t112" class="pln"><span class="n"><a href="#t112">112</a></span><span class="t">        <span class="str">""" Find service in SDC, check distribution."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t113" class="run"><span class="n"><a href="#t113">113</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Find Service in SDC *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t114" class="run"><span class="n"><a href="#t114">114</a></span><span class="t">        <span class="nam">service</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t115" class="run"><span class="n"><a href="#t115">115</a></span><span class="t">        <span class="nam">services</span> <span class="op">=</span> <span class="nam">Service</span><span class="op">.</span><span class="nam">get_all</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t116" class="run"><span class="n"><a href="#t116">116</a></span><span class="t">        <span class="key">for</span> <span class="nam">found_service</span> <span class="key">in</span> <span class="nam">services</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t117" class="run"><span class="n"><a href="#t117">117</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"Service %s is found, distribution %s"</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t118" class="pln"><span class="n"><a href="#t118">118</a></span><span class="t">                              <span class="nam">found_service</span><span class="op">.</span><span class="nam">name</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t119" class="pln"><span class="n"><a href="#t119">119</a></span><span class="t">                              <span class="nam">found_service</span><span class="op">.</span><span class="nam">distribution_status</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t120" class="run"><span class="n"><a href="#t120">120</a></span><span class="t">            <span class="key">if</span> <span class="nam">found_service</span><span class="op">.</span><span class="nam">name</span> <span class="op">==</span> <span class="nam">service_name</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t121" class="run"><span class="n"><a href="#t121">121</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Found Service %s in SDC"</span><span class="op">,</span> <span class="nam">found_service</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t122" class="run"><span class="n"><a href="#t122">122</a></span><span class="t">                <span class="nam">service</span> <span class="op">=</span> <span class="nam">found_service</span>&nbsp;</span><span class="r"></span></p>
    <p id="t123" class="run"><span class="n"><a href="#t123">123</a></span><span class="t">                <span class="key">break</span>&nbsp;</span><span class="r"></span></p>
    <p id="t124" class="run"><span class="n"><a href="#t124">124</a></span><span class="t">        <span class="key">return</span> <span class="nam">service</span>&nbsp;</span><span class="r"></span></p>
    <p id="t125" class="pln"><span class="n"><a href="#t125">125</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t126" class="run"><span class="n"><a href="#t126">126</a></span><span class="t">    <span class="key">def</span> <span class="nam">check_service_distribution</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">service</span><span class="op">,</span> <span class="nam">try_max</span><span class="op">,</span> <span class="nam">wait_time</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t127" class="pln"><span class="n"><a href="#t127">127</a></span><span class="t">        <span class="str">""" Check service distribution is complete."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t128" class="run"><span class="n"><a href="#t128">128</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"*Check if service is completly distributed *"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t129" class="run"><span class="n"><a href="#t129">129</a></span><span class="t">        <span class="nam">nb_try</span> <span class="op">=</span> <span class="num">0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t130" class="run"><span class="n"><a href="#t130">130</a></span><span class="t">        <span class="nam">service_distributed</span> <span class="op">=</span> <span class="key">False</span>&nbsp;</span><span class="r"></span></p>
    <p id="t131" class="run"><span class="n"><a href="#t131">131</a></span><span class="t">        <span class="key">while</span> <span class="nam">service_distributed</span> <span class="key">is</span> <span class="key">False</span> <span class="key">and</span> <span class="nam">nb_try</span> <span class="op">&lt;</span> <span class="nam">try_max</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t132" class="run"><span class="n"><a href="#t132">132</a></span><span class="t">            <span class="key">if</span> <span class="nam">service</span><span class="op">.</span><span class="nam">distributed</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t133" class="run"><span class="n"><a href="#t133">133</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Service %s is now distributed *******"</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t134" class="pln"><span class="n"><a href="#t134">134</a></span><span class="t">                                 <span class="nam">service</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t135" class="run"><span class="n"><a href="#t135">135</a></span><span class="t">                <span class="nam">service_distributed</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t136" class="run"><span class="n"><a href="#t136">136</a></span><span class="t">                <span class="key">break</span>&nbsp;</span><span class="r"></span></p>
    <p id="t137" class="run"><span class="n"><a href="#t137">137</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Service %s distribution not complete, status %s wait 10s"</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t138" class="pln"><span class="n"><a href="#t138">138</a></span><span class="t">                             <span class="nam">service</span><span class="op">.</span><span class="nam">name</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t139" class="pln"><span class="n"><a href="#t139">139</a></span><span class="t">                             <span class="nam">service</span><span class="op">.</span><span class="nam">distribution_status</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t140" class="run"><span class="n"><a href="#t140">140</a></span><span class="t">            <span class="nam">time</span><span class="op">.</span><span class="nam">sleep</span><span class="op">(</span><span class="nam">wait_time</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t141" class="run"><span class="n"><a href="#t141">141</a></span><span class="t">            <span class="nam">nb_try</span> <span class="op">+=</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t142" class="run"><span class="n"><a href="#t142">142</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">service_distributed</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t143" class="run"><span class="n"><a href="#t143">143</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">"Service %s not distributed"</span><span class="op">,</span> <span class="nam">service</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t144" class="run"><span class="n"><a href="#t144">144</a></span><span class="t">            <span class="nam">sys</span><span class="op">.</span><span class="nam">exit</span><span class="op">(</span><span class="num">1</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t145" class="pln"><span class="n"><a href="#t145">145</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t146" class="run"><span class="n"><a href="#t146">146</a></span><span class="t">    <span class="key">def</span> <span class="nam">check_service_instance_exists</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">service_subscription</span><span class="op">,</span> <span class="nam">instance_name</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t147" class="pln"><span class="n"><a href="#t147">147</a></span><span class="t">        <span class="str">""" Check if service_instance already exists."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t148" class="run"><span class="n"><a href="#t148">148</a></span><span class="t">        <span class="nam">service_instance</span> <span class="op">=</span> <span class="key">None</span>&nbsp;</span><span class="r"></span></p>
    <p id="t149" class="run"><span class="n"><a href="#t149">149</a></span><span class="t">        <span class="key">for</span> <span class="nam">service_element</span> <span class="key">in</span> <span class="nam">service_subscription</span><span class="op">.</span><span class="nam">service_instances</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t150" class="run"><span class="n"><a href="#t150">150</a></span><span class="t">            <span class="key">if</span> <span class="nam">service_element</span><span class="op">.</span><span class="nam">instance_name</span> <span class="op">==</span> <span class="nam">instance_name</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t151" class="run"><span class="n"><a href="#t151">151</a></span><span class="t">                <span class="nam">service_instance</span> <span class="op">=</span> <span class="nam">service_element</span>&nbsp;</span><span class="r"></span></p>
    <p id="t152" class="run"><span class="n"><a href="#t152">152</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"Service instance_name found %s "</span><span class="op">,</span> <span class="nam">service_element</span><span class="op">.</span><span class="nam">instance_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t153" class="run"><span class="n"><a href="#t153">153</a></span><span class="t">                <span class="key">break</span>&nbsp;</span><span class="r"></span></p>
    <p id="t154" class="run"><span class="n"><a href="#t154">154</a></span><span class="t">        <span class="key">return</span> <span class="nam">service_instance</span>&nbsp;</span><span class="r"></span></p>
    <p id="t155" class="pln"><span class="n"><a href="#t155">155</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t156" class="run"><span class="n"><a href="#t156">156</a></span><span class="t">    <span class="key">def</span> <span class="nam">check_service_instantiation</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">service_subscription</span><span class="op">,</span> <span class="nam">instance_name</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t157" class="pln"><span class="n"><a href="#t157">157</a></span><span class="t">        <span class="str">""" Check if service is now intantiated."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t158" class="run"><span class="n"><a href="#t158">158</a></span><span class="t">        <span class="nam">service_instance</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">check_service_instance_exists</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t159" class="pln"><span class="n"><a href="#t159">159</a></span><span class="t">            <span class="nam">service_subscription</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t160" class="pln"><span class="n"><a href="#t160">160</a></span><span class="t">            <span class="nam">instance_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t161" class="run"><span class="n"><a href="#t161">161</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">service_instance</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t162" class="run"><span class="n"><a href="#t162">162</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">"******** Service %s instantiation failed"</span><span class="op">,</span> <span class="nam">instance_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t163" class="run"><span class="n"><a href="#t163">163</a></span><span class="t">            <span class="nam">sys</span><span class="op">.</span><span class="nam">exit</span><span class="op">(</span><span class="num">1</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t164" class="run"><span class="n"><a href="#t164">164</a></span><span class="t">        <span class="key">return</span> <span class="nam">service_instance</span>&nbsp;</span><span class="r"></span></p>
    <p id="t165" class="pln"><span class="n"><a href="#t165">165</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t166" class="run"><span class="n"><a href="#t166">166</a></span><span class="t">    <span class="key">def</span> <span class="nam">check_service_instance_active</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">service_instance</span><span class="op">,</span> <span class="nam">wait_time</span><span class="op">,</span> <span class="nam">try_max</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t167" class="pln"><span class="n"><a href="#t167">167</a></span><span class="t">        <span class="str">"""Check if service instance is active."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t168" class="run"><span class="n"><a href="#t168">168</a></span><span class="t">        <span class="nam">nb_try</span> <span class="op">=</span> <span class="num">0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t169" class="run"><span class="n"><a href="#t169">169</a></span><span class="t">        <span class="nam">service_active</span> <span class="op">=</span> <span class="key">False</span>&nbsp;</span><span class="r"></span></p>
    <p id="t170" class="run"><span class="n"><a href="#t170">170</a></span><span class="t">        <span class="key">while</span> <span class="nam">service_active</span> <span class="key">is</span> <span class="key">False</span> <span class="key">and</span> <span class="nam">nb_try</span> <span class="op">&lt;</span> <span class="nam">try_max</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t171" class="run"><span class="n"><a href="#t171">171</a></span><span class="t">            <span class="key">if</span> <span class="nam">service_instance</span><span class="op">.</span><span class="nam">orchestration_status</span> <span class="op">==</span> <span class="str">"Active"</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t172" class="run"><span class="n"><a href="#t172">172</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Service Instance %s is active *******"</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t173" class="pln"><span class="n"><a href="#t173">173</a></span><span class="t">                                 <span class="nam">service_instance</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t174" class="run"><span class="n"><a href="#t174">174</a></span><span class="t">                <span class="nam">service_active</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t175" class="run"><span class="n"><a href="#t175">175</a></span><span class="t">                <span class="key">break</span>&nbsp;</span><span class="r"></span></p>
    <p id="t176" class="run"><span class="n"><a href="#t176">176</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Service %s instantiation not complete, Status: %s, wait 10s"</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t177" class="pln"><span class="n"><a href="#t177">177</a></span><span class="t">                             <span class="nam">service_instance</span><span class="op">.</span><span class="nam">name</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t178" class="pln"><span class="n"><a href="#t178">178</a></span><span class="t">                             <span class="nam">service_instance</span><span class="op">.</span><span class="nam">orchestration_status</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t179" class="run"><span class="n"><a href="#t179">179</a></span><span class="t">            <span class="nam">time</span><span class="op">.</span><span class="nam">sleep</span><span class="op">(</span><span class="nam">wait_time</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t180" class="run"><span class="n"><a href="#t180">180</a></span><span class="t">            <span class="nam">nb_try</span> <span class="op">+=</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t181" class="run"><span class="n"><a href="#t181">181</a></span><span class="t">        <span class="key">return</span> <span class="nam">service_active</span>&nbsp;</span><span class="r"></span></p>
    <p id="t182" class="pln"><span class="n"><a href="#t182">182</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t183" class="pln"><span class="n"><a href="#t183">183</a></span><span class="t">    <span class="com">#  pylint: disable=too-many-arguments</span>&nbsp;</span><span class="r"></span></p>
    <p id="t184" class="run"><span class="n"><a href="#t184">184</a></span><span class="t">    <span class="key">def</span> <span class="nam">instantiate_service</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t185" class="pln"><span class="n"><a href="#t185">185</a></span><span class="t">                            <span class="nam">instance_name</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t186" class="pln"><span class="n"><a href="#t186">186</a></span><span class="t">                            <span class="nam">service</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t187" class="pln"><span class="n"><a href="#t187">187</a></span><span class="t">                            <span class="nam">service_subscription</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t188" class="pln"><span class="n"><a href="#t188">188</a></span><span class="t">                            <span class="nam">cloud_region</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t189" class="pln"><span class="n"><a href="#t189">189</a></span><span class="t">                            <span class="nam">tenant</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t190" class="pln"><span class="n"><a href="#t190">190</a></span><span class="t">                            <span class="nam">customer</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t191" class="pln"><span class="n"><a href="#t191">191</a></span><span class="t">                            <span class="nam">owning_entity</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t192" class="pln"><span class="n"><a href="#t192">192</a></span><span class="t">                            <span class="nam">project</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t193" class="pln"><span class="n"><a href="#t193">193</a></span><span class="t">                            <span class="nam">try_max</span><span class="op">=</span><span class="num">10</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t194" class="pln"><span class="n"><a href="#t194">194</a></span><span class="t">                            <span class="nam">wait_time1</span><span class="op">=</span><span class="num">120</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t195" class="pln"><span class="n"><a href="#t195">195</a></span><span class="t">                            <span class="nam">wait_time2</span><span class="op">=</span><span class="num">10</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t196" class="pln"><span class="n"><a href="#t196">196</a></span><span class="t">        <span class="str">""" Instantiate service."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t197" class="run"><span class="n"><a href="#t197">197</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Instantiate Service *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t198" class="run"><span class="n"><a href="#t198">198</a></span><span class="t">        <span class="nam">service_instance</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">check_service_instance_exists</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t199" class="pln"><span class="n"><a href="#t199">199</a></span><span class="t">            <span class="nam">service_subscription</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t200" class="pln"><span class="n"><a href="#t200">200</a></span><span class="t">            <span class="nam">instance_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t201" class="run"><span class="n"><a href="#t201">201</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">service_instance</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t202" class="run"><span class="n"><a href="#t202">202</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Service Instance not existing: Instantiate *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t203" class="pln"><span class="n"><a href="#t203">203</a></span><span class="t">            <span class="com"># Instantiate service</span>&nbsp;</span><span class="r"></span></p>
    <p id="t204" class="run"><span class="n"><a href="#t204">204</a></span><span class="t">            <span class="nam">ServiceInstantiation</span><span class="op">.</span><span class="nam">instantiate_so_ala_carte</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t205" class="pln"><span class="n"><a href="#t205">205</a></span><span class="t">                <span class="nam">service</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t206" class="pln"><span class="n"><a href="#t206">206</a></span><span class="t">                <span class="nam">cloud_region</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t207" class="pln"><span class="n"><a href="#t207">207</a></span><span class="t">                <span class="nam">tenant</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t208" class="pln"><span class="n"><a href="#t208">208</a></span><span class="t">                <span class="nam">customer</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t209" class="pln"><span class="n"><a href="#t209">209</a></span><span class="t">                <span class="nam">owning_entity</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t210" class="pln"><span class="n"><a href="#t210">210</a></span><span class="t">                <span class="nam">project</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t211" class="pln"><span class="n"><a href="#t211">211</a></span><span class="t">                <span class="nam">service_instance_name</span><span class="op">=</span><span class="nam">instance_name</span>&nbsp;</span><span class="r"></span></p>
    <p id="t212" class="pln"><span class="n"><a href="#t212">212</a></span><span class="t">            <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t213" class="run"><span class="n"><a href="#t213">213</a></span><span class="t">            <span class="nam">time</span><span class="op">.</span><span class="nam">sleep</span><span class="op">(</span><span class="nam">wait_time1</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t214" class="pln"><span class="n"><a href="#t214">214</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t215" class="run"><span class="n"><a href="#t215">215</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Service Instance already existing *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t216" class="pln"><span class="n"><a href="#t216">216</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t217" class="run"><span class="n"><a href="#t217">217</a></span><span class="t">        <span class="nam">service_instance</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">check_service_instantiation</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t218" class="pln"><span class="n"><a href="#t218">218</a></span><span class="t">            <span class="nam">service_subscription</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t219" class="pln"><span class="n"><a href="#t219">219</a></span><span class="t">            <span class="nam">instance_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t220" class="pln"><span class="n"><a href="#t220">220</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t221" class="run"><span class="n"><a href="#t221">221</a></span><span class="t">        <span class="nam">service_active</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">check_service_instance_active</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t222" class="pln"><span class="n"><a href="#t222">222</a></span><span class="t">            <span class="nam">service_instance</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t223" class="pln"><span class="n"><a href="#t223">223</a></span><span class="t">            <span class="nam">wait_time2</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t224" class="pln"><span class="n"><a href="#t224">224</a></span><span class="t">            <span class="nam">try_max</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t225" class="pln"><span class="n"><a href="#t225">225</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t226" class="run"><span class="n"><a href="#t226">226</a></span><span class="t">        <span class="key">if</span> <span class="nam">service_active</span> <span class="key">is</span> <span class="key">False</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t227" class="run"><span class="n"><a href="#t227">227</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">"Service %s instantiation failed"</span><span class="op">,</span> <span class="nam">service_instance</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t228" class="run"><span class="n"><a href="#t228">228</a></span><span class="t">            <span class="nam">sys</span><span class="op">.</span><span class="nam">exit</span><span class="op">(</span><span class="num">1</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t229" class="run"><span class="n"><a href="#t229">229</a></span><span class="t">        <span class="key">return</span> <span class="nam">service_instance</span>&nbsp;</span><span class="r"></span></p>
    <p id="t230" class="pln"><span class="n"><a href="#t230">230</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t231" class="run"><span class="n"><a href="#t231">231</a></span><span class="t">    <span class="key">def</span> <span class="nam">add_vnf_to_service</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">service_instance</span><span class="op">,</span> <span class="nam">platform</span><span class="op">,</span> <span class="nam">line_of_business</span><span class="op">,</span> <span class="nam">wait_time</span><span class="op">=</span><span class="num">10</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t232" class="pln"><span class="n"><a href="#t232">232</a></span><span class="t">        <span class="str">""" Add vnf to instantiated service."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t233" class="pln"><span class="n"><a href="#t233">233</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t234" class="run"><span class="n"><a href="#t234">234</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Get VNFs in Service Model *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t235" class="run"><span class="n"><a href="#t235">235</a></span><span class="t">        <span class="nam">vnfs</span> <span class="op">=</span> <span class="nam">service_instance</span><span class="op">.</span><span class="nam">service_subscription</span><span class="op">.</span><span class="nam">sdc_service</span><span class="op">.</span><span class="nam">vnfs</span>&nbsp;</span><span class="r"></span></p>
    <p id="t236" class="pln"><span class="n"><a href="#t236">236</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t237" class="run"><span class="n"><a href="#t237">237</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Create VNFs *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t238" class="run"><span class="n"><a href="#t238">238</a></span><span class="t">        <span class="key">for</span> <span class="nam">vnf</span> <span class="key">in</span> <span class="nam">vnfs</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t239" class="run"><span class="n"><a href="#t239">239</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"Check if VNF instance of class %s exist"</span><span class="op">,</span> <span class="nam">vnf</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t240" class="run"><span class="n"><a href="#t240">240</a></span><span class="t">            <span class="nam">vnf_found</span> <span class="op">=</span> <span class="key">False</span>&nbsp;</span><span class="r"></span></p>
    <p id="t241" class="run"><span class="n"><a href="#t241">241</a></span><span class="t">            <span class="key">for</span> <span class="nam">vnf_instance</span> <span class="key">in</span> <span class="nam">service_instance</span><span class="op">.</span><span class="nam">vnf_instances</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t242" class="run"><span class="n"><a href="#t242">242</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"VNF instance %s checked in Service Instance "</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t243" class="pln"><span class="n"><a href="#t243">243</a></span><span class="t">                                  <span class="nam">vnf_instance</span><span class="op">.</span><span class="nam">vnf_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t244" class="run"><span class="n"><a href="#t244">244</a></span><span class="t">                <span class="key">if</span> <span class="nam">vnf_instance</span><span class="op">.</span><span class="nam">vnf_name</span> <span class="op">==</span> <span class="nam">vnf</span><span class="op">.</span><span class="nam">name</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t245" class="run"><span class="n"><a href="#t245">245</a></span><span class="t">                    <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"VNF instance %s found in Service Instance "</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t246" class="pln"><span class="n"><a href="#t246">246</a></span><span class="t">                                      <span class="nam">vnf_instance</span><span class="op">.</span><span class="nam">vnf_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t247" class="run"><span class="n"><a href="#t247">247</a></span><span class="t">                    <span class="nam">vnf_found</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t248" class="run"><span class="n"><a href="#t248">248</a></span><span class="t">                    <span class="key">break</span>&nbsp;</span><span class="r"></span></p>
    <p id="t249" class="run"><span class="n"><a href="#t249">249</a></span><span class="t">            <span class="key">if</span> <span class="nam">vnf_found</span> <span class="key">is</span> <span class="key">False</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t250" class="run"><span class="n"><a href="#t250">250</a></span><span class="t">                <span class="nam">vnf_instantiation</span> <span class="op">=</span> <span class="nam">service_instance</span><span class="op">.</span><span class="nam">add_vnf</span><span class="op">(</span><span class="nam">vnf</span><span class="op">,</span> <span class="nam">line_of_business</span><span class="op">,</span> <span class="nam">platform</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t251" class="run"><span class="n"><a href="#t251">251</a></span><span class="t">                <span class="key">while</span> <span class="key">not</span> <span class="nam">vnf_instantiation</span><span class="op">.</span><span class="nam">finished</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t252" class="run"><span class="n"><a href="#t252">252</a></span><span class="t">                    <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"Wait for VNF %s instantiation"</span><span class="op">,</span> <span class="nam">vnf</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t253" class="run"><span class="n"><a href="#t253">253</a></span><span class="t">                    <span class="nam">time</span><span class="op">.</span><span class="nam">sleep</span><span class="op">(</span><span class="nam">wait_time</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t254" class="pln"><span class="n"><a href="#t254">254</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t255" class="run"><span class="n"><a href="#t255">255</a></span><span class="t">    <span class="key">def</span> <span class="nam">instantiate_vf_modules</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">service_instance</span><span class="op">,</span> <span class="nam">service_name</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t256" class="pln"><span class="n"><a href="#t256">256</a></span><span class="t">        <span class="str">"""Add Vf modules for each vnf."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t257" class="mis show_mis"><span class="n"><a href="#t257">257</a></span><span class="t">        <span class="key">for</span> <span class="nam">vnf_instance</span> <span class="key">in</span> <span class="nam">service_instance</span><span class="op">.</span><span class="nam">vnf_instances</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t258" class="mis show_mis"><span class="n"><a href="#t258">258</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"VNF instance %s found in Service Instance "</span><span class="op">,</span> <span class="nam">vnf_instance</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t259" class="mis show_mis"><span class="n"><a href="#t259">259</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Get VfModules in VNF Model *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t260" class="mis show_mis"><span class="n"><a href="#t260">260</a></span><span class="t">            <span class="nam">vf_module</span> <span class="op">=</span> <span class="nam">vnf_instance</span><span class="op">.</span><span class="nam">vnf</span><span class="op">.</span><span class="nam">vf_module</span>&nbsp;</span><span class="r"></span></p>
    <p id="t261" class="pln"><span class="n"><a href="#t261">261</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t262" class="mis show_mis"><span class="n"><a href="#t262">262</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** Create VF Module %s *******"</span><span class="op">,</span> <span class="nam">vf_module</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t263" class="mis show_mis"><span class="n"><a href="#t263">263</a></span><span class="t">            <span class="nam">vnf_parameters</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_vnf_parameters</span><span class="op">(</span><span class="nam">service_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t264" class="mis show_mis"><span class="n"><a href="#t264">264</a></span><span class="t">            <span class="nam">vf_module_instantiation</span> <span class="op">=</span> <span class="nam">vnf_instance</span><span class="op">.</span><span class="nam">add_vf_module</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t265" class="pln"><span class="n"><a href="#t265">265</a></span><span class="t">                <span class="nam">vf_module</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t266" class="pln"><span class="n"><a href="#t266">266</a></span><span class="t">                <span class="nam">vnf_parameters</span><span class="op">=</span><span class="nam">vnf_parameters</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t267" class="mis show_mis"><span class="n"><a href="#t267">267</a></span><span class="t">            <span class="nam">nb_try</span> <span class="op">=</span> <span class="num">0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t268" class="mis show_mis"><span class="n"><a href="#t268">268</a></span><span class="t">            <span class="nam">nb_try_max</span> <span class="op">=</span> <span class="num">30</span>&nbsp;</span><span class="r"></span></p>
    <p id="t269" class="mis show_mis"><span class="n"><a href="#t269">269</a></span><span class="t">            <span class="key">while</span> <span class="key">not</span> <span class="nam">vf_module_instantiation</span><span class="op">.</span><span class="nam">finished</span> <span class="key">and</span> <span class="nam">nb_try</span> <span class="op">&lt;</span> <span class="nam">nb_try_max</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t270" class="mis show_mis"><span class="n"><a href="#t270">270</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Wait for vf module instantiation"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t271" class="mis show_mis"><span class="n"><a href="#t271">271</a></span><span class="t">                <span class="nam">nb_try</span> <span class="op">+=</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t272" class="mis show_mis"><span class="n"><a href="#t272">272</a></span><span class="t">                <span class="nam">time</span><span class="op">.</span><span class="nam">sleep</span><span class="op">(</span><span class="num">20</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t273" class="mis show_mis"><span class="n"><a href="#t273">273</a></span><span class="t">            <span class="key">if</span> <span class="nam">vf_module_instantiation</span><span class="op">.</span><span class="nam">finished</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t274" class="mis show_mis"><span class="n"><a href="#t274">274</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"VfModule %s instantiated"</span><span class="op">,</span> <span class="nam">vf_module</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t275" class="pln"><span class="n"><a href="#t275">275</a></span><span class="t">            <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t276" class="mis show_mis"><span class="n"><a href="#t276">276</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">"VfModule instantiation %s failed"</span><span class="op">,</span> <span class="nam">vf_module</span><span class="op">.</span><span class="nam">name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t277" class="pln"><span class="n"><a href="#t277">277</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t278" class="run"><span class="n"><a href="#t278">278</a></span><span class="t">    <span class="key">def</span> <span class="nam">instantiate</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">cloud_resources</span><span class="op">,</span> <span class="nam">service</span><span class="op">=</span><span class="key">None</span><span class="op">,</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t279" class="pln"><span class="n"><a href="#t279">279</a></span><span class="t">        <span class="str">"""Instantiate a Service with ONAP.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t280" class="pln"><span class="n"><a href="#t280">280</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t281" class="pln"><span class="n"><a href="#t281">281</a></span><span class="t"><span class="str">        The instantiation consists in the different steps:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t282" class="pln"><span class="n"><a href="#t282">282</a></span><span class="t"><span class="str">          * Create the customer in AAI</span>&nbsp;</span><span class="r"></span></p>
    <p id="t283" class="pln"><span class="n"><a href="#t283">283</a></span><span class="t"><span class="str">          * Retrieve Service from SDC</span>&nbsp;</span><span class="r"></span></p>
    <p id="t284" class="pln"><span class="n"><a href="#t284">284</a></span><span class="t"><span class="str">          * Declare subcription, link to tenant in AAI</span>&nbsp;</span><span class="r"></span></p>
    <p id="t285" class="pln"><span class="n"><a href="#t285">285</a></span><span class="t"><span class="str">          * Instantiate the service instance (SO)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t286" class="pln"><span class="n"><a href="#t286">286</a></span><span class="t"><span class="str">          * Create the VNF instance (SO)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t287" class="pln"><span class="n"><a href="#t287">287</a></span><span class="t"><span class="str">          * preload the VNF parameters in the SDNC</span>&nbsp;</span><span class="r"></span></p>
    <p id="t288" class="pln"><span class="n"><a href="#t288">288</a></span><span class="t"><span class="str">          * Create the VF module instance (SO)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t289" class="pln"><span class="n"><a href="#t289">289</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t290" class="mis show_mis"><span class="n"><a href="#t290">290</a></span><span class="t">        <span class="nam">customer</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">create_customer</span><span class="op">(</span><span class="nam">settings</span><span class="op">.</span><span class="nam">GLOBAL_CUSTOMER_ID</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t291" class="mis show_mis"><span class="n"><a href="#t291">291</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">service</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t292" class="mis show_mis"><span class="n"><a href="#t292">292</a></span><span class="t">            <span class="nam">service</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">find_service_sdc</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">service_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t293" class="mis show_mis"><span class="n"><a href="#t293">293</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">check_service_distribution</span><span class="op">(</span><span class="nam">service</span><span class="op">,</span> <span class="num">10</span><span class="op">,</span> <span class="num">10</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t294" class="mis show_mis"><span class="n"><a href="#t294">294</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">logger</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"******** AAI declaration *******"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t295" class="mis show_mis"><span class="n"><a href="#t295">295</a></span><span class="t">        <span class="nam">service_subscription</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">declare_service_subscription</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t296" class="pln"><span class="n"><a href="#t296">296</a></span><span class="t">            <span class="nam">customer</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t297" class="pln"><span class="n"><a href="#t297">297</a></span><span class="t">            <span class="nam">service</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t298" class="mis show_mis"><span class="n"><a href="#t298">298</a></span><span class="t">        <span class="nam">tenant</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">check_tenant_exists</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t299" class="pln"><span class="n"><a href="#t299">299</a></span><span class="t">            <span class="nam">cloud_resources</span><span class="op">.</span><span class="nam">cloud_region</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t300" class="pln"><span class="n"><a href="#t300">300</a></span><span class="t">            <span class="nam">settings</span><span class="op">.</span><span class="nam">TENANT_NAME</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t301" class="mis show_mis"><span class="n"><a href="#t301">301</a></span><span class="t">        <span class="nam">service_subscription</span><span class="op">.</span><span class="nam">link_to_cloud_region_and_tenant</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t302" class="pln"><span class="n"><a href="#t302">302</a></span><span class="t">            <span class="nam">cloud_resources</span><span class="op">.</span><span class="nam">cloud_region</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t303" class="pln"><span class="n"><a href="#t303">303</a></span><span class="t">            <span class="nam">tenant</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t304" class="pln"><span class="n"><a href="#t304">304</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t305" class="mis show_mis"><span class="n"><a href="#t305">305</a></span><span class="t">        <span class="nam">service_instance</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">instantiate_service</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t306" class="pln"><span class="n"><a href="#t306">306</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">instance_name</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t307" class="pln"><span class="n"><a href="#t307">307</a></span><span class="t">            <span class="nam">service</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t308" class="pln"><span class="n"><a href="#t308">308</a></span><span class="t">            <span class="nam">service_subscription</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t309" class="pln"><span class="n"><a href="#t309">309</a></span><span class="t">            <span class="nam">cloud_resources</span><span class="op">.</span><span class="nam">cloud_region</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t310" class="pln"><span class="n"><a href="#t310">310</a></span><span class="t">            <span class="nam">tenant</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t311" class="pln"><span class="n"><a href="#t311">311</a></span><span class="t">            <span class="nam">customer</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t312" class="pln"><span class="n"><a href="#t312">312</a></span><span class="t">            <span class="nam">cloud_resources</span><span class="op">.</span><span class="nam">owning_entity</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t313" class="pln"><span class="n"><a href="#t313">313</a></span><span class="t">            <span class="nam">cloud_resources</span><span class="op">.</span><span class="nam">project</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t314" class="pln"><span class="n"><a href="#t314">314</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t315" class="mis show_mis"><span class="n"><a href="#t315">315</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">add_vnf_to_service</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t316" class="pln"><span class="n"><a href="#t316">316</a></span><span class="t">            <span class="nam">service_instance</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t317" class="pln"><span class="n"><a href="#t317">317</a></span><span class="t">            <span class="nam">cloud_resources</span><span class="op">.</span><span class="nam">platform</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t318" class="pln"><span class="n"><a href="#t318">318</a></span><span class="t">            <span class="nam">cloud_resources</span><span class="op">.</span><span class="nam">line_of_business</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t319" class="mis show_mis"><span class="n"><a href="#t319">319</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">instantiate_vf_modules</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t320" class="pln"><span class="n"><a href="#t320">320</a></span><span class="t">            <span class="nam">service_instance</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t321" class="pln"><span class="n"><a href="#t321">321</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">service_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t322" class="mis show_mis"><span class="n"><a href="#t322">322</a></span><span class="t">        <span class="key">return</span> <span class="nam">service_instance</span>&nbsp;</span><span class="r"></span></p>
</div>
<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v5.1</a>,
            created at 2020-07-17 14:15
        </p>
    </div>
</div>
</body>
</html>
